本文主要是介绍Heartbeat 与DRBD 配置过程,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!
我的PC机都只有1个网卡,所以我用串口使双机通讯;
192.168.119.1是我的路由器的IP,作为一个域外的服务器,检测域内服务器是否正常;
首先配置host文件:
127.0.0.1 localhost
127.0.1.1 ubuntu-Bing192.168.119.102 ubuntu-Bing
192.168.119.103 Lab-Server
cp /usr/local/ha/share/doc/authkeys /usr/local/ha/etc/ha.dcp /usr/local/ha/share/doc/ha.cf /usr/local/ha/etc/ha.dcp /usr/local/ha/share/doc/haresources /usr/local/ha/etc/ha.d
debugfile /var/log/ha-debug
logfile /var/log/ha-log
logfacility local0
keepalive 2
deadtime 30
warntime 10
initdead 120
baud 19200
serial /dev/ttyS0 # Linux
auto_failback on
node ubuntu-Bing
node Lab-Server
ping 192.168.119.1
respawn hacluster /usr/lib/ocf/resource.d/heartbeat/pingd -m 100 -d 5s
apiauth pingd gid=haclient uid=haclustercompression bz2
compression_threshold 2
authkeys文件:
auth 1
1 crc
haresource文件:
ubuntu-Bing IPaddr::192.168.119.101/24/eth0 drbddisk::r0 Filesystem::/dev/drbd0::/mnt/drbd::ext3
resource.d目录下 drbddisk 脚本
#!/bin/bash
#
# This script is intended to be used as resource script by heartbeat
#
# Copright 2003-2008 LINBIT Information Technologies
# Philipp Reisner, Lars Ellenberg
#
###DEFAULTFILE="/etc/default/drbd"
DRBDADM="/sbin/drbdadm"if [ -f $DEFAULTFILE ]; then. $DEFAULTFILE
fiif [ "$#" -eq 2 ]; thenRES="$1"CMD="$2"
elseRES="all"CMD="$1"
fi## EXIT CODES
# since this is a "legacy heartbeat R1 resource agent" script,
# exit codes actually do not matter that much as long as we conform to
# http://wiki.linux-ha.org/HeartbeatResourceAgent
# but it does not hurt to conform to lsb init-script exit codes,
# where we can.
# http://refspecs.linux-foundation.org/LSB_3.1.0/
#LSB-Core-generic/LSB-Core-generic/iniscrptact.html
####drbd_set_role_from_proc_drbd()
{
local out
if ! test -e /proc/drbd; then
ROLE="Unconfigured"
return
fidev=$( $DRBDADM sh-dev $RES )
minor=${dev#/dev/drbd}
if [[ $minor = *[!0-9]* ]] ; then
# sh-minor is only supported since drbd 8.3.1
minor=$( $DRBDADM sh-minor $RES )
fi
if [[ -z $minor ]] || [[ $minor = *[!0-9]* ]] ; then
ROLE=Unknown
return
fiif out=$(sed -ne "/^ *$minor: cs:/ { s/:/ /g; p; q; }" /proc/drbd); then
set -- $out
ROLE=${5%/**}
: ${ROLE:=Unconfigured} # if it does not show up
else
ROLE=Unknown
fi
}case "$CMD" instart)
# try several times, in case heartbeat deadtime
# was smaller than drbd ping time
try=6
while true; do
$DRBDADM primary $RES && break
let "--try" || exit 1 # LSB generic error
sleep 1
done
;;stop)
# heartbeat (haresources mode) will retry failed stop
# for a number of times in addition to this internal retry.
try=3
while true; do
$DRBDADM secondary $RES && break
# We used to lie here, and pretend success for anything != 11,
# to avoid the reboot on failed stop recovery for "simple
# config errors" and such. But that is incorrect.
# Don't lie to your cluster manager.
# And don't do config errors...
let --try || exit 1 # LSB generic error
sleep 1
done
;;status)
if [ "$RES" = "all" ]; thenecho "A resource name is required for status inquiries."exit 10
fi
ST=$( $DRBDADM role $RES )
ROLE=${ST%/**}
case $ROLE in
Primary|Secondary|Unconfigured)
# expected
;;
*)
# unexpected. whatever...
# If we are unsure about the state of a resource, we need to
# report it as possibly running, so heartbeat can, after failed
# stop, do a recovery by reboot.
# drbdsetup may fail for obscure reasons, e.g. if /var/lock/ is
# suddenly readonly. So we retry by parsing /proc/drbd.
drbd_set_role_from_proc_drbd
esac
case $ROLE in
Primary)
echo "running (Primary)"
exit 0 # LSB status "service is OK"
;;
Secondary|Unconfigured)
echo "stopped ($ROLE)"
exit 3 # LSB status "service is not running"
;;
*)
# NOTE the "running" in below message.
# this is a "heartbeat" resource script,
# the exit code is _ignored_.
echo "cannot determine status, may be running ($ROLE)"
exit 4 # LSB status "service status is unknown"
;;
esac
;;*)
echo "Usage: drbddisk [resource] {start|stop|status}"
exit 1
;;
esacexit 0
先配置好DRBD服务,然后再启动heartbeat服务;测试Heartbeat!
停止主服务器的heartbeat服务,然后查看/mnt/drbd下是否可以看到文件!如果可以,说明成功了!
这篇关于Heartbeat 与DRBD 配置过程的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!